/*
 * signals/surprise.c --
 *
 *	Depending on the platform you run this program on, you might
 *	see that signals may interrupt even simple assignments. The
 *	alarm system call arranges for a SIGALRM signal to be
 *	delivered to the calling process after a number of seconds.
 */

#include <stdlib.h>
#include <signal.h>
#include <stdint.h>
#include <stdio.h>
#include <inttypes.h>
#include <unistd.h>

static struct two_words { int64_t a, b; } memory;

static void
handler(int signum)
{
    if (memory.a != memory.b) {
	printf("%" PRId64 ",%" PRId64 "\n", memory.a, memory.b);
    }
    (void) signal(SIGALRM, handler);	/* reinstall the signal handler */
    alarm(1);
}

int
main(void)
{
    static struct two_words zeros = { 0, 0 }, ones = { 1, 1 };
    
    (void) signal(SIGALRM, handler);
    memory = zeros;
    alarm(1);
    while (1) {
	memory = zeros;
	memory = ones;
    }
    return EXIT_SUCCESS;
}
